package GUI;

import java.awt.BorderLayout;
import java.awt.Color;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;



import java.sql.*;

//import oracle.jdbc.*;
import oracle.jdbc.pool.OracleDataSource;

public class MainWin extends JFrame {
	
	
	OracleConn pol = new OracleConn();
	Thread polaczenie1 = new Thread(pol);
	Thread rozlaczenie1 = new Thread(){
		public void run(){
			try {
				pol.disconnect();
				JOptionPane.showMessageDialog(null, "Rozczono pomyslnie");
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}
	};
	
	OracleDataSource ods;
	Connection conn;
	DatabaseMetaData meta;
	Statement stmt;


	/**
	 * <b>JPanel, kontener po prawej stronie okienka. Przechowuje wszystkie
	 * przyciski</b>
	 */
	private SWorker swork = new SWorker(pol,this);
	private JPanel cp = new JPanel();
	private JScrollPane Manipulator = new JScrollPane();
	private BorderLayout layout = new BorderLayout();
	private JMenuBar MyMenu = new JMenuBar();
	private JMenuItem FileConnect = new JMenuItem("Connect");
	private JMenuItem FileDisconnect = new JMenuItem("Disconnect");
	private JMenu MenuFile = new JMenu("File");
	private JMenu Add = new JMenu("Add");
	private JMenuItem Worker = new JMenuItem("new Worker");
	private JMenuItem ExitItem = new JMenuItem("Exit");
	private JTextArea PoleText = new JTextArea(10, 34);
	private JMenuItem JsetUser = new JMenuItem("Set login prameters");
	private JMenuItem JSerwer = new JMenuItem("Set Oracle serwer name");
	private JMenu Search = new JMenu("Search");
	private JMenuItem SearchWorker = new JMenuItem("Search Worker");

	// Przyciski
	private JButton JConnect = new JButton("Connect");
	private JButton JDisconnect = new JButton("Disconnect");
	private JButton JClear = new JButton("Clear");
	private JButton JExit = new JButton("Exit");

	private JLabel etykieta = new JLabel("Firma kurierska XYZ");
	

	
	private ActionListener addWorker = new ActionListener() {
		
		@Override
		public void actionPerformed(ActionEvent e) {
			
			new newWorker(pol.getStatement());
			
		}
	};
	
	private ActionListener logparam = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent e) {
			String u = JOptionPane.showInputDialog(cp, "Enter your login:",
					"Login", JOptionPane.PLAIN_MESSAGE);
			String p = JOptionPane.showInputDialog(cp,
					"Enter your password (Not safe mode!):", "Password",
					JOptionPane.PLAIN_MESSAGE);
			pol.setUser(u);
			pol.setPasswd(p);
		}

	};
	
	private ActionListener ActionSearchWorker = new ActionListener(){

		@Override
		public void actionPerformed(ActionEvent arg0) {

			if(pol.isConnected()){
				
				swork.setVisible(true);
				
			}
			else
				PoleText.append("Nie jeste poczony!\n");
			
		}
		
	};

	private ActionListener polaczenie = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			polaczenie1.run();
		}		
	};
	
	private ActionListener rozlaczenie = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			rozlaczenie1.run();
			
		}
	};

	private ActionListener SerwerName = new ActionListener() {
		
		@Override
		public void actionPerformed(ActionEvent e) {
			String s = JOptionPane.showInputDialog("Enter your Oracle database server address: ", pol.getSerwerName());
			pol.setSerwerName(s);
			
		}
	};
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * @param args
	 * @author ukasz Sdek
	 */
	public static void main(final String[] args) {
		new MainWin();

	}
	
	public MainWin(){
		init();

	}

	public void init() {
		setLocationByPlatform(true);
		setVisible(true);
		setSize(500, 600);
		setTitle("Firma kurierska 1.0 beta");
		setResizable(false);
		setLayout(layout);
		
		GridLayout lay = new GridLayout(14, 1);
		lay.layoutContainer(cp);
		lay.setVgap(10);
		lay.setHgap(10);
		cp.setLayout(lay);
		add(cp, BorderLayout.EAST);
		
		JPanel polnoc = new JPanel();
		add(polnoc, BorderLayout.NORTH);
		
		polnoc.add(etykieta, BorderLayout.CENTER);
		
		swork.addWindowListener(new WindowListener() {
			
			@Override
			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowClosing(WindowEvent e) {
				PoleText.append(Pojemnik.poj);
				
			}
			
			@Override
			public void windowClosed(WindowEvent e) {
				PoleText.append(Pojemnik.poj);
				
			}
			
			@Override
			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
		});

		JConnect.setToolTipText("<html><b><i>Connect to database</i></b></html>");
		cp.add(JConnect);
		JConnect.addActionListener(polaczenie);
		cp.add(JDisconnect);
		JDisconnect.addActionListener(rozlaczenie);
		cp.add(JClear);
		JClear.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				PoleText.setText("");

			}
		});
		cp.add(JExit);
		JExit.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		PoleText.setAutoscrolls(true);
		PoleText.setWrapStyleWord(true);
		PoleText.setLineWrap(true);
		PoleText.setEditable(false);
		
		//PoleText.setText("test\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\ntest\n");
		PoleText.setBounds(0, 0, 400, 600);
		// Manipulator.setMinimumSize( new Dimension(300,500));
		Manipulator = new JScrollPane(PoleText);
		Manipulator.setBorder(BorderFactory.createLineBorder(Color.black));
		// Manipulator.add(PoleText);
		add(Manipulator, BorderLayout.WEST);
		Manipulator.setOpaque(true);

		Manipulator.setWheelScrollingEnabled(true);
		// menu
		setJMenuBar(MyMenu);
		MyMenu.add(MenuFile);
		MyMenu.add(Add);
		MyMenu.add(Search);
		Search.add(SearchWorker);
		Add.add(Worker);
		Worker.addActionListener(addWorker);
		KeyStroke ctrlW = KeyStroke.getKeyStroke(KeyEvent.VK_W,InputEvent.CTRL_MASK);
		Worker.setAccelerator(ctrlW);
		FileConnect.addActionListener(polaczenie);
		MenuFile.add(FileConnect);
		
		MenuFile.add(FileDisconnect);
		MenuFile.add(JsetUser);
		MenuFile.add(JSerwer);
		KeyStroke ctrlP = KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK);
		KeyStroke ctrlC = KeyStroke.getKeyStroke(KeyEvent.VK_C,InputEvent.CTRL_MASK);
		KeyStroke ctrlD = KeyStroke.getKeyStroke(KeyEvent.VK_D,InputEvent.CTRL_MASK);
		KeyStroke ctrlX = KeyStroke.getKeyStroke(KeyEvent.VK_X,InputEvent.CTRL_MASK);
		KeyStroke ctrlL = KeyStroke.getKeyStroke(KeyEvent.VK_L,InputEvent.CTRL_MASK);
		FileConnect.setAccelerator(ctrlC);
		FileConnect.setMnemonic('F');
		SearchWorker.setIcon(new ImageIcon("worker.gif"));
		SearchWorker.addActionListener(ActionSearchWorker);
		FileConnect.setIcon(new ImageIcon("oracle.gif"));
		ExitItem.setIcon(new ImageIcon("exit.png"));
		FileDisconnect.setIcon(new ImageIcon("disconect.gif"));
		JsetUser.setIcon(new ImageIcon("m5.gif"));
		JSerwer.setIcon(new ImageIcon("server.gif"));
		Worker.setIcon(new ImageIcon("worker.gif"));
		Worker.setMnemonic('W');
		JSerwer.setAccelerator(ctrlP);
		ExitItem.setAccelerator(ctrlX);
		JSerwer.addActionListener(SerwerName);
		JsetUser.addActionListener(logparam);
		JsetUser.setAccelerator(ctrlL);
		FileDisconnect.addActionListener(rozlaczenie);
		FileDisconnect.setAccelerator(ctrlD);
		MenuFile.add(ExitItem);
		ExitItem.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				System.exit(0);

			}

		});
				
		BufferedImage image = null;
		try {
			image = ImageIO.read(getClass().getResource("/tux.gif"));
		} catch (IOException e) {
		}
		setIconImage(image);
	}
	}
