drop TABLE PRACOWNIK;
drop TABLE STANOWISKO;
drop TABLE RACHUNKOWAOSC;
drop TABLE KLIENT;
drop TABLE PRZESYLKA;
drop TABLE ODDZIAL_REGINALNY;


CREATE TABLE ODDZIAL_REGINALNY(
  ID_ODZIAL INT CONSTRAINT ID_ODZIAL PRIMARY KEY,
  MIASTO VARCHAR(60),
  ULICA VARCHAR(60),
  NR_LOKALU VARCHAR(10),
  KOD_POCZTOWY VARCHAR(6)
);

CREATE TABLE PRACOWNIK(
  ID_PRACOWNIK INT CONSTRAINT ID_PRACOWNIK PRIMARY KEY,
  ID_PRZELOZONY INT references PRACOWNIK(ID_PRACOWNIK),
  IMIE VARCHAR(20),
  NAZWISKO VARCHAR(40),
  MIASTO VARCHAR(60),
  ULICA VARCHAR(60),
  UMOWA VARCHAR(20)
);

CREATE TABLE STANOWISKO(
  NAZWA VARCHAR(40) CONSTRAINT NAZWA PRIMARY KEY,
  PODSTAWA_PLACY FLOAT,
  OBOWIAZKI VARCHAR(160)
);

CREATE TABLE RACHUNKOWAOSC(
  ID_ODZIAL INT references ODDZIAL_REGINALNY(ID_ODZIAL),
  MIESIAC INT,
  ROK INT,
  KOSZT FLOAT,
  ZYSK FLOAT
);

CREATE TABLE KLIENT(
  ID_KLIENT INT CONSTRAINT ID_KLIENT PRIMARY KEY,
  ID_ODDZIAL INT references ODDZIAL_REGINALNY(ID_ODZIAL),
  IMIE VARCHAR(20),
  NAZWISKO VARCHAR(40),
  MIASTO VARCHAR(60),
  ULICA VARCHAR(60),
  NR_LOKALU VARCHAR(10),
  KOD_POCZTOWY VARCHAR(6),
  TELEFON VARCHAR(12)
);

CREATE TABLE PRZESYLKA(
  ID_PRZESYLKA INT  CONSTRAINT ID_PRZESYLKA PRIMARY KEY,
  ID_KLIENT INT references KLIENT(ID_KLIENT),
  ROZMIAR VARCHAR(20),
  DATA_NADANIA DATE NOT NULL,
  PRIORYTET INT,
  WAGA FLOAT,
  MIASTO VARCHAR(60),
  ULICA VARCHAR(60),
  NR_LOKALU VARCHAR(10),
  KOD_POCZTOWY VARCHAR(20),
  KOSZT FLOAT,
  CENA FLOAT,
  STAN VARCHAR(20)
);